#include <stdio.h>
#include <ctype.h>
#include <stdlib.h>
#include "cons.h"

/* Copyright (C) 1992,2000 Bisqwit (http://iki.fi/bisqwit/)
 * No warranty. You are free to modify this source, and to
 * distribute modified sources, as long as you keep the
 * existing copyright messages intact and as long as you
 * remember to add your own copyright markings.
 */

static unsigned xsize, ysize;
static BYTE *map;

static void TranslatePix(BYTE *m)
{
    int c=0x2C, ch="0123456789ABCDEF"[*m & 15];
    switch(*m)
    {
        case 0:
        {
            BYTE a=m[-xsize-3],b=m[-xsize-2],d=m[-xsize-1];
            BYTE e=m[-1],  f=m[1];
            BYTE g=m[xsize+1],h=m[xsize+2],i=m[xsize+3];
            c = 8;
            if(a||b||d||e||f||g||h||i)
                if(!a || !i)
                    ch = (b&&d&&e&&f&&g&&h) ? '\\' : '+';
                else if(!d || !g)
                    ch = (a&&b&&e&&f&&h&&i) ? '/' : '+';
                else if(!e || !f)
                    ch = (a&&b&&d&&g&&h&&i) ? '-' : '+';
                else 
                    ch = (a&&d&&e&&f&&g&&i) ? '|' : '+';
            else
                ch = '#';
            break;
        }
        case 1:
            c = 13, ch = '^';
            break;
        case 2:
        {
            BYTE a=m[-xsize-3],b=m[-xsize-2],d=m[-xsize-1];
            BYTE e=m[-1],  f=m[1];
            BYTE g=m[xsize+1],h=m[xsize+2],i=m[xsize+3];
            if(a==15||b==15||d==25
            || e==15||f==15||g==15
            || h==15||i==15)
            	c=12, ch = 'x';
            else
	            c=5, ch = 'i';
            break;
        }
        case 3:
            c = 14, ch = 'z';
            break;
        case 4:
            c = 6, ch = 'd';
            break;
        case 5:
            c = 15, ch = '?';
            break;
        case 6:
            c = 4, ch = 'V'; /* ?? */
            break;
        case 7:
            c = 5, ch = 'h';
            break;
        case 8:
            c = 8, ch = 'c';
            break;
        case 9: 
            c = 1, ch = 'r';
            break;
        case 10:
            c = 7; ch = '!';
            break;
        case 11:
            c = 6, ch = 'b'; /* ?? */
            break;
        case 12:
            c = 6, ch = 'y';
            break;
        case 13:
            c = 15, ch = '%';
            break;
        case 14:
            c = 10, ch = 'f';
            break;
        case 15:
            c = 12, ch = 's';
            break;
        case 16:
            c = 1, ch = 'R';
            break;
        case 17:
            c = 2, ch = 'F';
            break;
        case 18:
            c = 1, ch = '-';
            break;
        case 19:
            c = 10, ch = 'v'; /* ?? */
            break;
        case 20:
            c = 11, ch = 'j'; /* ?? */
            break;
        case 32:
        	c = 11, ch = 'X'; /* mapped road */
    }
    SetAttr(c);
    Gputchar(ch);
}

static void Search(void)
{
	const char **lines = NULL;
	int linecount = 0;
	
	SetAttr(0x07);
	ClrScr();
	SetAttr(0x30);
	Gprintf("Will search for location. Copypaste your map. Empty line terminates the map.");
	ClrEOL();
	Gprintf("\n");
	
	/*
	for(;;)
	{
		char *s;
		lines = (const char **) realloc(++linecount * (sizeof(const char *)));
		s = lines[linecount-1] = (char *)malloc(512);
	}
	*/
}

static void Viewer(void)
{
    unsigned xp=0, yp=0;
    unsigned y, x;
    InitCons();
Redo:
	GetTerminalSize();
	--COLS;
	
	if(xp >= xsize-COLS)xp = xsize-COLS-1;
	if(yp >= ysize-LINES)yp = ysize-LINES-1;
	
    if(!kbhit())
        for(y=0; y<LINES-1; ++y)
        {    
            BYTE *m = map + (1+y+yp)*(xsize+2) + xp+1;
            GotoXY(1,y+1);
            for(x=0; x<COLS; ++x)
                TranslatePix(m++);
        }
        
    GotoXY(1, LINES);
    SetAttr(0x1F);
    Gprintf("Keys: Arrows, Escape = Q = ^C, ^L = ^R, S = search element");
    ClrEOL();

    fflush(stdout);
    
    for(;;)
    {
        int key = getkey();
        if(key==Esc || key=='' || toupper(key)=='Q')break;
        if(key==KbRt && xp<xsize-COLS) { xp += 8; goto Redo;}
        if(key==KbLt) { if(xp > 8)xp -= 8;else xp=0; goto Redo;}
        if(key==KbDn && yp<ysize-LINES) { yp += 8; goto Redo;}
        if(key==KbUp) { if(yp > 8)yp -= 8;else yp=0; goto Redo;}
        if(key=='' || key=='')RefreshScreen();
        if(key=='S' || key=='s')
        	Search();
    }
    
    GotoXY(1, LINES);
    SetAttr(7);
    ClrEOL();
    
    DoneCons();
}

static void FindRoad(void)
{

}

int main(void)
{
    FILE *fp = fopen("batmap.raw", "rt");
    unsigned y;
    fseek(fp, 8, SEEK_SET);
    
    xsize = fgetc(fp); xsize = fgetc(fp) | (xsize<<8);
    ysize = fgetc(fp); ysize = fgetc(fp) | (ysize<<8);
    
    map = (BYTE *)malloc((xsize+2)*(ysize+2));
    
    fseek(fp, 0x320, SEEK_SET);
    for(y=0; y<ysize; ++y)
        fread(&map[(y+1)*(xsize+2)+1], 1, xsize, fp);
    fclose(fp);
    
    FindRoad();
    
    Viewer();
    
    return 0;
}
