#ifndef __USECURSES_H
#define __USECURSES_H

#include "sizes.h"

/* Copyright (C) 1992,2000 Bisqwit (http://iki.fi/bisqwit/)
 * No warranty. You are free to modify this source, and to
 * distribute modified sources, as long as you keep the
 * existing copyright messages intact and as long as you
 * remember to add your own copyright markings.
 */

#define vidcache 1

#define Random(val) (((val)<2)?0:(random()%(val)))
#define Randomize() srand(time(NULL)+getppid());

#define SH_DENYALL (0600 + 0060 + 0006)
#define SH_DENYNONE 0000
#define SH_DENYWRITE (S_IWUSR|S_IWGRP|S_IWOTH)
#define SH_DENYREAD (S_IRUSR|S_IRGRP|S_IROTH)
#define fsopen _fsopen

#define SH_DENYRW SH_DENYALL

extern void DoneCons(void);
extern void InitCons(void);

extern char *strlwr(char *string);
extern char *strupr(char *string);
extern int strnicmp(const char *eka, const char *toka, long Max);

#define stricmp(a,b) strnicmp((a),(b), 0x7FFFFFFFL)

extern char *strccat(char *Dest, char Ch);

extern void Error(const char *Where);

extern int kbhit(void);
extern int getch(void);

#undef SetAttr
extern void SetAttr(BYTE Attr);
extern void GotoXY(unsigned x, unsigned y);
extern void ClrScr(void);
extern void ClrEOL(void);

extern BYTE TextAttr;
extern unsigned LINES, COLS;
extern unsigned WhereX,WhereY;
#define WhereX() WhereX
#define WhereY() WhereY
extern void ShowCursor(void);
extern void HideCursor(void);
extern BYTE Gputchar(BYTE c);
extern int Gprintf(const char *fmt, ...)
	#ifdef __GNUC__
		__attribute__((format(printf,1,2)))
	#endif
	;
extern void RefreshScreen(void);
extern void GetTerminalSize(void);

extern int getkey(void);
enum {
	KbUp=400,KbDn,KbLt,KbRt,
	F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,
	Home,End,PgUp,PgDn,Tab,ShiftTab,
	Backspace,Pause,Del,Ins,Alt,
	Ctrl=-64,Esc=27
};

#endif
