#include <fstream>
#include <cctype>
#include <string>
#include <unistd.h>

static string nik;

static string lower(const string &s)
{
	string t=s;
	unsigned a, b;
	for(a=0, b=t.size(); a<b; ++a)
		t[a]=tolower(t[a]);
	return t;
}

static void TransResponse(const string &resp, const string &nik, const string &adverb)
{
	string result;
	string tmp = resp;
	
	while(tmp.size() && tmp[0] == '>')tmp.erase(0, 1);
	
	if(tmp == "You need to do that to someone.")
	{
		result = "$!";
		tmp = "";
	}
	
	while(tmp.size())
	{
    	unsigned a;
    	for(a=0; a<tmp.size() && isalnum(tmp[a]); ++a);
    	
    	string tmp2(tmp, 0, a);
    	tmp.erase(0, a);
    	
    	if(lower(tmp2) == lower(nik) || tmp2 == "yourself")
    		result += "$S";
    	else if(tmp2 == adverb)
    		result += "$A";
    	else if(lower(tmp2) == "you")
    		if(tmp.substr(0, 4) == " are")
    		{
    			result += "$B";
    			tmp.erase(0, 4);
    		}
    		else
	    		result += "$W";
    	else if(tmp2 == "your")
    		if(tmp.substr(0, 4) == " own")
    		{
    			result += "$O";
    			tmp.erase(0, 4);
    		}
    		else
    			result += "$G";
    	else
    		result += tmp2;
    	
    	while(tmp.size() && !isalnum(tmp[0]))
    	{
    		result += tmp[0];
    		tmp.erase(0, 1);
    	}
	}
	cerr << "*** " << result << endl;
}

static void WaitAns(const char *what = "You", int trans=1)
{
	string s;
p1:
	if(!cin.good())
	{
		usleep(200000);
		cin.clear();
	}
	getline(cin, s);
	if(s.find("You feel fully healed") != s.npos)goto p1;
	if(s.find("You sizzle with magical") != s.npos)goto p1;
	if(s.find("You are fully recovered") != s.npos)goto p1;
	if(s.find("You hear some birds") != s.npos)goto p1;
	if(s.find("You feel your luck") != s.npos)goto p1;
	if(s.find("You grow a little") != s.npos)goto p1;
	
//	cerr << "*** Got '" << s << "'\n";
	if(s.find(what) == s.npos)goto p1;
	if(trans==1)TransResponse(s, nik, "icily");
	if(trans==2)nik = s;
}

static void TestFeeling(const string &s)
{
	cerr << "* " << s << ":\n";
	cout << s << endl;
	WaitAns();
	cout << s << " icily\n";
	WaitAns();
	cout << s << " at " << nik << endl;
	WaitAns();
	cout << s << " at " << nik << " icily\n";
	WaitAns();
	usleep(250000);
}

int main(int, const char *const *argv)
{
	ifstream fp("feelings.txt");
	nik = argv[1] ? argv[1] : "bisqwit";
	
	cout << "2\n\nw\n";
	
	cout << "prompt <name>\n";
	WaitAns("Your prompt", 0);
	cout << endl;
	WaitAns("Guest", 2);
	cout << "prompt >\n\n";
	WaitAns("Your prompt", 0);
	sleep(3);
	cout << endl << endl;
	WaitAns(">", 0);
	
	while(fp.good())
	{
		string s;
		getline(fp, s);
		if(s[0]=='-')break;
	redo:
		unsigned n = s.find(' ');
		if(n == s.npos)
			TestFeeling(s);
		else
		{
			string s2(s, 0, n);
			TestFeeling(s2);
			while(s[++n]==' ');
			s.erase(0, n);
			goto redo;
		}
	}
	
	return 0;
}
