#include <string.h>

static char delim = '|';

static const char *stat[] =
{
	"pathetic", "pitiful", "sad", "bad", "tiny",
	"little", "meager", "feeble", "poor", "paltry",
	"crude", "weak", "slight", "low", "mediocre",
	"average", "decent", "adequate", "good", "nice",
	"great", "excellent", "impressive", "incredible", "superb",
	"awesome", "dazzling", "magnificent", "unearthly", "divine",
	NULL
};
static const char *statcha[] =
{
	"dreadful", "horrid", "ugly", "eyesore", "tolerable",
	"average", "nice", "attractive", "good-looking", "gorgeous",
	NULL
};
static const char *statsiz[] =
{
	"tiny", "little", "small", "short", "average",
	"big", "large", "huge", "colossal", "enormous",
	NULL
};

typedef struct playerstats
{
	int hp,hpmax,
        sp,spmax,
        ep,epmax,
        level,
        exp,
        tp,
        cash,bank,
        invweight,
        roomcount,
        battime;
	char
        str[16],
        dex[16],
        con[16],
        int[16],
        wis[16],
        cha[16],
        siz[16],
        align[16];
} playerstats;

static playerstats stats;
           
static void send(const char *fmt, ...)
{
}

static void setwindow(int y1,int y2)
{
}

static void initbat(void)
{
	send("sc colour off");
	send("sc set &[[ hp:<hp>/<maxhp> sp:<sp>/<maxsp> ep:<ep>/<maxep> lv:<mortlevel> str:<str> dex:<dex> con:<con> int:<int> wis:<wis> cha:<cha> siz:<siz> tp:<tp> align:<alignment> exp:<exp> cash:<cash>+<bank> inv:<weight> exl:<rooms> tme:<hour>:<min> &");
	send("sc on");
	send("set delim %c", delim);
}

static int statcolr(int pros)
{
	static const char c[] = {5,4,12,14,11,10};
	if(pros>100)return 15;
	if(pros<0)return 8;
	return c[pros*(sizeof(c)-1)/100];
}
static int getstat(const char *s)
{
	int ind;
	const char **t = stat;
	for(ind=0; *t && strcmp(*t, s); ind++)t++;
	return *t ? ind * 100 / (sizeof(stat) / sizeof(*t) - 1) : -1;
}
static int getstatcha(const char *s)
{
	int ind;
	const char **t = statcha;
	for(ind=0; *t && strcmp(*t, s); ind++)t++;
	return *t ? ind * 100 / (sizeof(statcha) / sizeof(*t) - 1) : -1;
}
static int getstatsiz(const char *s)
{
	int ind;
	const char **t = statsiz;
	for(ind=0; *t && strcmp(*t, s); ind++)t++;
	return *t ? ind * 100 / (sizeof(statsiz) / sizeof(*t) - 1) : -1;
}
static int addcolr(int diff)
{
	return diff<0 ? 15 : diff>0 ? 10 : 0;
}

static void drawstats(void)
{
	static playerstats old;
	
	SetWindow(0, 3);
	GotoXY(0, 0);
	SetAttr(15); Gprintf("HP"); SetAttr(statcolr(stats.hp*100/stats.hpmax)); Gprintf("%5d");
	SetAttr(15); Gprintf("/");   SetAttr(statcolr(stats.hp*100/stats.hpmax)); Gprintf("%-5d");
	SetAttr(addcolr(stats.hp-old.hp)); Gprintf("%+-7d", stats.hp-old.hp);
	
	GotoXY(0, 1);
	SetAttr(15); Gprintf("SP"); SetAttr(statcolr(stats.sp*100/stats.spmax)); Gprintf("%5d");
	SetAttr(15); Gprintf("/");   SetAttr(statcolr(stats.sp*100/stats.spmax)); Gprintf("%-5d");
	SetAttr(addcolr(stats.sp-old.sp)); Gprintf("%+-7d", stats.sp-old.sp);
	
	GotoXY(0, 2);
	SetAttr(15); Gprintf("EP"); SetAttr(statcolr(stats.ep*100/stats.epmax)); Gprintf("%5d");
	SetAttr(15); Gprintf("/");   SetAttr(statcolr(stats.ep*100/stats.epmax)); Gprintf("%-5d");
	SetAttr(addcolr(stats.ep-old.ep)); Gprintf("%+-7d", stats.ep-old.ep);
	
	GotoXY(20, 0);
	SetAttr(15); Gprintf("EXP"); SetAttr(14); Gprintf("%9d");
	SetAttr(addcolr(stats.exp-old.exp)); Gprintf("%+-11d", stats.exp-old.exp);
	
	GotoXY(20, 1);
	SetAttr(15); Gprintf("CASH"); SetAttr(14); Gprintf("%9d", stats.cash); SetAttr(15); Gprintf(" GP");
	GotoXY(20, 2);
	SetAttr(15); Gprintf("CASH"); SetAttr(14); Gprintf("%9d", stats.bank); SetAttr(15); Gprintf(" GP");
	
	{int a=getstat(stat.str);/*, b=getstat(old.str);*/
	GotoXY(45, 0);
	SetAttr(15); Gprintf("STR"); SetAttr(statcolr(a)); Gprintf("%4d%%"); }
	{int a=getstat(stat.int);/*, b=getstat(old.int);*/
	SetAttr(15); Gprintf("  INT"); SetAttr(statcolr(a)); Gprintf("%4d%%"); }
	{int a=getstatsiz(stat.siz);/*, b=getstatsiz(old.siz);*/
	SetAttr(15); Gprintf("  SIZ"); SetAttr(statcolr(a)); Gprintf("%4d%%"); }
	
	{int a=getstat(stat.dex);/*, b=getstat(old.dex);*/
	GotoXY(45, 1);
	SetAttr(15); Gprintf("DEX"); SetAttr(statcolr(a)); Gprintf("%4d%%"); }
	{int a=getstat(stat.wis);/*, b=getstat(old.int);*/
	SetAttr(15); Gprintf("  INT"); SetAttr(statcolr(a)); Gprintf("%4d%%"); }
	{int a=getstatsiz(stat.siz);/*, b=getstatsiz(old.siz);*/
	SetAttr(15); Gprintf("  EXPLORED:");}
	
	{int a=getstat(stat.con);/*, b=getstat(old.con);*/
	GotoXY(45, 1);
	SetAttr(15); Gprintf("CON"); SetAttr(statcolr(a)); Gprintf("%4d%%"); }
	{int a=getstatcha(stat.cha);/*, b=getstatcha(old.cha);*/
	SetAttr(15); Gprintf("  CHA"); SetAttr(statcolr(a)); Gprintf("%4d%%"); }
	SetAttr(14); Gprintf("%10d", stat.roomcount);}
	
	GotoXY(0, 3);
	SetAttr(0x1F);
	Gprintf("TIME ");
	SetAttr(0x1E);
	Gprintf("%02d:%02d", stat.battime/60,stat.battime%60);
	SetAttr(0x1F);
	Gprintf("%40s ", "ALIGN");
	SetAttr(0x1E);
	Gprintf("%s", stat.align);
	ClrEOL();
	SetAttr(addcolr(stats.roomcount-old.roomcount)|0x10);
	Gprintf("%+*d", 22-strlen(stat.align), stat.roomcount-old.roomcount);
}
/*
HP 1000/1000 +1000  EXP 12345678 +1234567890 STR 100%  INT 100%  SIZ 100%
MP 1000/1000 +1000  CASH 12345678 GP         DEX 100%  WIS 100%  EXPLORED:
EP 1000/1000 +1000  BANK 10000000 GP         CON 100%  CHA 100%  12345678
TIME 23:59 _________________________________ ALIGN GOOD_RELIGIOUS   +1000 _____
*/
